






	HIWORD MACRO ParamFen
		mov eax,ParamFen
		shr eax,16
	ENDM
	LOWORD MACRO ParamFen
		mov eax,ParamFen
		and eax,0FFFFh
	ENDM

      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM

      PuPo MACRO M1, M2
        push M2
        pop  M1
      ENDM
	InsTxt MACRO Name, Text:VARARG
	LOCAL lbl
		jmp lbl
		Name db Text,0
	lbl:
	ENDM
	return MACRO valeur
		mov eax,valeur
		ret
	ENDM
	
	
		ZEROLOCALES MACRO dernierelocale:REQ
			mov ecx,ebp
			lea edx,dernierelocale
			sub ecx,edx
			.if ecx != 0
				push edi
				mov edi,edx
				mov al,0
				cld
				rep stosb
				pop edi			
			.endif
		ENDM


    ; --------------------------------------------------------
    ; Cre une donne en data,renvoie l'tiquette de la chaine
    ; La cration du nom de l'tiquette est facultatif
    ; la macro vrifie la syntaxe des chaines et tiquettes
    ; ---------------------------------------------------------
      CREDATA MACRO quoted_text:REQ,NomdeChaine
		LOCAL Local_Etiquette,verif
	IFNB <NomdeChaine>			;present
		verif SUBSTR <NomdeChaine>,1,1
      		IFIDN verif,<">            ;si le premier caractere est "
			.ERR  <ETIQUETTE SUPRIMER les " >			
		ENDIF
	Local_Etiquette TEXTEQU <NomdeChaine>		;changer le nom d'tiquette
	ENDIF
	verif SUBSTR <quoted_text>,1,1				
	IFDIF verif,<">
		.ERR  <CHAINE AJOUTER LES " >
	ENDIF
	
		.data
		Local_Etiquette db quoted_text,0
		.code
		EXITM <Local_Etiquette>
      ENDM
    ; ----------------------------------------------------
    ; Sort l' adresse de la chaine crer, SADR("chaine")
    ; -----------------------------------------------------
      	SADR MACRO quoted_text:REQ,NomdeChaine
        	EXITM <ADDR CREDATA(quoted_text,NomdeChaine)>
      	ENDM
    ; ----------------------------------------------------
    ; Sort l' offset de la chaine crer, SADR("chaine")
    ; -----------------------------------------------------
	SOFF MACRO quoted_text:REQ,NomdeChaine
        	EXITM <Offset CREDATA(quoted_text,NomdeChaine)>
      	ENDM	

  ; ---------------------------------------------------
  ; return an arguments specified in "num" from a macro
  ; argument list or "-1" if the number is out of range
  ; ---------------------------------------------------
    getarg MACRO num:REQ,args:VARARG
      LOCAL cnt, txt
      cnt = 0
      FOR arg, <args>
        cnt = cnt + 1
        IF cnt EQ num
          txt TEXTEQU <arg>     ;; set "txt" to content of arg num
          EXITM
        ENDIF
      ENDM
      IFNDEF txt
        txt TEXTEQU <-1>        ;; return -1 if num out of range
      ENDIF
      EXITM txt
    ENDM
	
  ; -----------------------------------------------
  ; count the number of arguments passed to a macro
  ; This is a slightly modified 1990 MASM 6.0 macro
  ; -----------------------------------------------
    argcount MACRO args:VARARG
      LOCAL cnt
      cnt = 0
      FOR item, <args>
        cnt = cnt + 1
      ENDM
      EXITM %cnt                ;; return as a number
    ENDM		
;la macro peut s'crire plus simplement
;mais hlas,la boucle FOR ... gnre un "internal error" lorsque le fichier inclus
;contient des macros,les macro argcount et getarg sont la pour y remdier
LIB  MACRO args:VARARG
	LOCAL acnt,buffer,var,boucle,buf1
	acnt = argcount(args)			;macro argcount , nb d'arguments
	var = 1
	:boucle
	buffer equ getarg(var,args)		;macro getarg

	buf1 CATSTR <include \masm32\include\>,buffer,<.inc>
	buf1

	buf1 CATSTR <includelib \masm32\lib\>,buffer,<.lib>
	buf1

	var = var + 1
	IF var LE acnt
	goto boucle
	ENDIF
ENDM



	comment 
	lea edx,FindeProgramme
	invoke InstalleExceptions,SADR("c:\masm32\ref\dbghelp.dll"),\
			DebutdeProgramme,edx
	.if eax == 0
		jmp Findeminus
	.endif
	mov Hdbghelp,eax 
	

;--------------- macro pour exception ------------------------------------------------
	;usage
	;EXCEPT ("je me trouve dans macro.inc"),Nomproc,Param1,Param2.....
	;remplace: invoke Nomproc,Param1,Param2

	EXCEPT MACRO NomProc:REQ,parameters:VARARG
		LOCAL Local_Etiquette
		LOCAL localinvoke
		;rajouter des push ii pour augmenter le nombre de renseignements		
		xor eax,eax	;retour	
		push eax								;pointeur +24
		push EBP     ;sauvegarde ebp  					;pointeur +20
		lea eax,localinvoke
		push eax								;pointeur +16 la pile
		
		mov eax,ADRESSE NomProc						;pointeur +12
					;la phrase identifiant l'erreur
		push eax        	;
		lea eax,Local_Etiquette
		push eax								;pointeur +8
		lea eax,HANDLER	;la nouvelle routine d'exceptions
		push eax								;pointeur +4
		assume FS:NOTHING
		push FS:[0]       	;conserve l'ancien pointeur sur ERR      ;pointeur +0
		mov FS:[0],esp      	;remplacer l'ancien pointeur sur ERR par le nouveau,--
		localinvoke:		;---------------ce qui du meme coup sauvegarde esp
		invoke parameters	;rajouter la ligne tel que
		mov [esp+24],eax	;tout s'est bien passer,prserve la valeur de retour
		Local_Etiquette:		
		mov eax,[esp+24]	;prend la valeur de retour ,modifi en cas d'exceptions
		pop FS:[0]          	;retablir l'ancien err quand la zone protge est termine
		add esp,24          	;6 dword en pile effacer
	ENDM
	
	ADRESSE MACRO bidule:REQ
		EXITM <offset CREDATA (bidule)>
	ENDM

	HAUTEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).bottom                 ; y bas origine coin haut gauche 0,0
		sub     eax,(RECT ptr [ebx]).top	  			; y haut	
		pop ebx
	EXITM <eax>
	ENDM
	LARGEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).right       ; x coin droit bas  origine coin haut gauche 0,0
		sub     eax, (RECT ptr [ebx]).left      ; x coin gauche haut 
		pop ebx
	EXITM <eax>
	ENDM

